// ADHOCANALYSIS.JS
;FR.LOGMANAGER = {};

$.extend(FR.LOGMANAGER, {
	_init : function(config, needTitle) {
		this.config = config;
		
		var regions = [];
		this.$center = $('#fr-logmanager-center');
		this.$west = $('#fr-logmanager-west');
		regions.push({region : "center", el : this.$center});
		if (needTitle != false) {
			regions.push({region : "north", el : $('#fr-logmanager-north')});
		} else {
			$('#fr-logmanager-north').hide();
		}
		regions.push({region : "west", el : this.$west});
		var bd = $('body');
		var $container = bd.asComponent({type:'border',items : regions});
		$container.doLayout();
		window.onresize = function() {
			$container.doLayout();
		};
		
		var self = this;
		var button = $('<button type="button"></button>')
			.text('̨')
			.css("width", 153).css("height", 53)
			.appendTo($("#fr-logmanager-consolebn"));
		if ($.fn.button) {
			button.button();
		}
		button.click(function() {
			self.initConsole();
		});
		
		button = $('<button type="button"></button>')
			.html('ִм¼<br/>ѯ')
			.css("width", 153).css("height", 53)
			.appendTo($("#fr-logmanager-exe"));
		if ($.fn.button) {
			button.button();
		}
		button.click(function() {
			$("#fr-logmanager-console").hide();
			$("#logFrame").show();
			FR.doHyperlinkByPost('${servletURL}?op=fr_log_exe', {}, "logFrame");
		});
		
		button = $('<button type="button"></button>')
			.html('¼<br/>ѯ')
			.css("width", 153).css("height", 53)
			.appendTo($("#fr-logmanager-exp"));
		if ($.fn.button) {
			button.button();
		}
		button.click(function() {
			$("#fr-logmanager-console").hide();
			$("#logFrame").show();
			FR.doHyperlinkByPost('${servletURL}?op=fr_log_exp', {}, "logFrame");
		});
		
		button = $('<button type="button"></button>')
			.html('ӡ¼<br/>ѯ')
			.css("width", 153).css("height", 53)
			.appendTo($("#fr-logmanager-prt"));
		if ($.fn.button) {
			button.button();
		}
		button.click(function() {
			$("#fr-logmanager-console").hide();
			$("#logFrame").show();
			FR.doHyperlinkByPost('${servletURL}?op=fr_log_prt', {}, "logFrame");
		});
		
		button = $('<button type="button"></button>')
			.html('<br/>ѯ')
			.css("width", 153).css("height", 53)
			.appendTo($("#fr-logmanager-err"));
		if ($.fn.button) {
			button.button();
		}
		button.click(function() {
			$("#fr-logmanager-console").hide();
			$("#logFrame").show();
			FR.doHyperlinkByPost('${servletURL}?op=fr_log_err', {}, "logFrame");
		});
		
		button = $('<button type="button"></button>')
			.html('¼<br/>ѯ')
			.css("width", 153).css("height", 53)
			.appendTo($("#fr-logmanager-errinfo"));
		if ($.fn.button) {
			button.button();
		}
		button.click(function() {
			$("#fr-logmanager-console").hide();
			$("#logFrame").show();
			FR.doHyperlinkByPost('${servletURL}?op=fr_log_err_info&__bypagesize__=false', {}, "logFrame");
		});
		
		this.initConsole();
	},
	
	initConsole : function() {
		$("#logFrame").hide();
		
		var self = this;
		
		if (!this.console_inited) {
			if (this.config.rdok) {
				$('#fr-logmanager-state').text('').css("color", 'green');
			} else {
				$('#fr-logmanager-state').text(',ѹر').css("color", 'red');
			}
			
			var config = {
				type : 'checkbox',
				name : 'exe',
				widgetName : 'exe',
				width : 120,
				height : 20
			};
			this.exeBox = $('#fr-logmanager-exebn').asComponent(config);
			this.exeBox.selected(this.config.exe);
			
			config = {
				type : 'checkbox',
				name : 'exp',
				widgetName : 'exp',
				width : 120,
				height : 20
			};
			this.expBox = $('#fr-logmanager-expbn').asComponent(config);
			this.expBox.selected(this.config.exp);
			
			config = {
				type : 'checkbox',
				name : 'prt',
				widgetName : 'prt',
				width : 120,
				height : 20
			};
			this.prtBox = $('#fr-logmanager-prtbn').asComponent(config);
			this.prtBox.selected(this.config.prt);
			
			config = {
				type : 'checkbox',
				name : 'err',
				widgetName : 'err',
				width : 120,
				height : 20
			};
			this.errBox = $('#fr-logmanager-errbn').asComponent(config);
			this.errBox.selected(this.config.err);
			
			var listener = {};
			listener.eventName = FR.Events.CLICK;
			listener.action = function() {
				$.ajax({					
					url : '${servletURL}',
					type : 'POST',
					data : {
						op : 'fr_log_config',
						exe : self.exeBox.selected(),
						exp : self.expBox.selected(),
						prt : self.prtBox.selected(),
						err : self.errBox.selected()
					},
					async : true,
					complete : function(res, status) {
						if (res.responseText == 'success') {
							FR.Msg.toast(FR.i18n.Successfully);
						} else {
							FR.Msg.toast(FR.i18n.Failed);
						}
					}
				});
			};
			
			config = {
				type : "button",
				name : 'savebn',
				tablable : true,
				text : '',
				width: 50,
				listeners : [listener]
			};
			$('#fr-logmanager-savebn').asComponent(config);
			
			this.console_inited = true;
		} else {
			$.ajax({					
				url : '${servletURL}',
				type : 'POST',
				data : {
					op : 'fr_log_get_config'
				},
				async : false,
				complete : function(res, status) {
					var config = FR.jsonDecode(res.responseText);
					if (config.rdok) {
						$('#fr-logmanager-state').text('').css("color", 'green');
					} else {
						$('#fr-logmanager-state').text(',ѹر').css("color", 'red');
					}
					
					self.exeBox.selected(config.exe);
					self.expBox.selected(config.exp);
					self.prtBox.selected(config.prt);
					self.errBox.selected(config.err);
				}
			});
		}
		
		$("#fr-logmanager-console").show();
	}
});